var CreateManager = {
	//arrays with information for each field
	aFieldNames: null,
	aFieldTypes: null,

	sCurrentTable: null,
	sObject: null,
	sOperation: null,

	//could go in preferences, think over
	numOfEmptyColumns: 20, //shown during create table

	loadEmptyColumns: function() {
		var node = document.getElementById("rows-all");
		this.numOfEmptyColumns = sm_getPreferenceValue("maxColumnsInTable", 20);

		var row = document.getElementById("row-template");
		for(var i = 0; i < this.numOfEmptyColumns; i++) {
			var clone = row.cloneNode(true);
			clone.setAttribute("id", "row-" + i);
			clone.setAttribute("style", "");
			var children = clone.childNodes;
			var id;
      for (var j = 0; j < children.length; j++) {
        id = children[j].getAttribute("id") + "-" + i;
        children[j].setAttribute("id", id);
      };

			node.appendChild(clone);
		}
	},

	loadOccupiedColumns: function(sTableName) {
		var node = document.getElementById("rows-all");
		this.numOfEmptyColumns = sm_getPreferenceValue("maxColumnsInTable", 20);
		
		var row = document.getElementById("row-template");
		for(var i = 0; i < this.numOfEmptyColumns; i++) {
			var clone = row.cloneNode(true);
			clone.setAttribute("id", "row-" + i);
			clone.setAttribute("style", "");
			var children = clone.childNodes;
			var id;
		   for (var j = 0; j < children.length; j++) 
		   {
		   		id = children[j].getAttribute("id") + "-" + i;
		   		children[j].setAttribute("id", id);
		   };
		  
			node.appendChild(clone);
		}
	},
		
	loadCreateTableDialog: function () {
		Database = window.arguments[0];
		var sTableName = window.arguments[1];
		this.sObject = "TABLE";
		
		if (sTableName == null)
    	this.loadEmptyColumns();
    else
    	this.loadOccupiedColumns();
    window.sizeToContent();
	},
		
  selectTable: function(sID) {
    var sTable = document.getElementById(sID).value;
		//function names have been assigned in the main load functions
		if(this.sObject == "INDEX")
			this.loadFieldNames(sTable);
	},

	loadCreateIndexDialog: function () {
		Database = window.arguments[0];
		this.sCurrentTable = window.arguments[1];

		this.sObject = "INDEX";

    this.loadTableNames("tabletoindex", this.sCurrentTable);

		this.loadFieldNames(this.sCurrentTable);
	},

  loadFieldNames: function(sTableName) {
		document.title = "Create Index on Table " + sTableName;
		var info = Database.getTableColumns(sTableName);
		var cols = info[0];
		this.aFieldNames = [], aTypes = [];
		for(var i = 0; i < cols.length; i++) {
			this.aFieldNames.push(cols[i][info[1]["name"][0]]);
			aTypes.push(cols[i][info[1]["type"][0]]);
		}
		var vbox = document.getElementById("definecolumns");

		while (vbox.firstChild) {
			 vbox.removeChild(vbox.firstChild);
		}
			
		for(var i = 0; i < this.aFieldNames.length; i++) {
			var radgr = document.createElement("radiogroup");
			radgr.setAttribute("id", "rad-" + (i+1));

			var hbox = document.createElement("hbox");
			hbox.setAttribute("flex", "1");
			hbox.setAttribute("style", "margin:2px 3px 2px 3px");
			hbox.setAttribute("align", "right");
			
			var lbl = document.createElement("label");
			lbl.setAttribute("value", (i+1) + ". " + this.aFieldNames[i]);
			lbl.setAttribute("style", "padding-top:5px;width:100px;");
			lbl.setAttribute("accesskey", (i+1));
			lbl.setAttribute("control", "rad-" + (i+1));
			hbox.appendChild(lbl);
			
			var radio;
			radio = document.createElement("radio");
			radio.setAttribute("label", "Do not use");
			radio.setAttribute("selected", "true");
			radio.setAttribute("value", "");
			hbox.appendChild(radio);

			radio = document.createElement("radio");
			radio.setAttribute("label", "Ascending");
			radio.setAttribute("value", sm_backquote(this.aFieldNames[i]) + " ASC");
			hbox.appendChild(radio);

			radio = document.createElement("radio");
			radio.setAttribute("label", "Descending");
			radio.setAttribute("value", sm_backquote(this.aFieldNames[i]) + " DESC");
			hbox.appendChild(radio);

			radgr.appendChild(hbox);
			
			vbox.appendChild(radgr);
		}
	},

	doOKCreateIndex: function() {
		var name = document.getElementById("indexname").value;
		if(name == "") {
			alert("Name cannot be null");
			return false;
		}

		var tbl = this.sCurrentTable;
		var dup = document.getElementById("duplicatevalues").selectedItem.value;
		
		var radgr, radval;
		var cols = "";
		for(var i = 0; i < this.aFieldNames.length; i++) {
			radgr = document.getElementById("rad-" + (i+1));
			radval = radgr.value;
			if(radval != "") {
				if(cols != "")
					radval = ", " + radval;
				
				cols = cols + radval;
			}
		}	
		if(cols == "") {
			alert("No Fields selected");
			return false;
		}
		
		var sQuery = "CREATE " + dup + " INDEX " + sm_backquote(name) + " ON " +
        sm_backquote(tbl) +	" (" + cols + ")";
		return Database.confirmAndExecute([sQuery], "Create Index " + name, "confirm.create");
	},

	loadCreateViewDialog: function () {
		Database = window.arguments[0];
		this.sCurrentTable = window.arguments[1];

		document.title = "Create View";
		this.sObject = "VIEW";
	},
	
	loadCreateTriggerDialog: function () {
		Database = window.arguments[0];
		this.sCurrentTable = window.arguments[1];

		this.sObject = "trigger";
    this.loadTableNames("tabletoindex", this.sCurrentTable);
	},

  //used for create index/trigger dialogs; shows normal(0) & temp(2) tables
  loadTableNames: function(sListBoxId, sTableName) {
		var listboxTable = document.getElementById(sListBoxId);

		var aNormTableNames = Database.getObjectList("table", 0);
		var aTempTableNames = Database.getObjectList("table", 2);
		var aTableNames = aNormTableNames.concat(aTempTableNames);

		PopulateDropDownItems(aTableNames, listboxTable, sTableName);
  },

	doOK: function() {
	},
		
	modifyTable: function(sOperation, sTable, sColumn) {
		if (sOperation == "addColumn") {
			var aQueries = [];
			var coldef = sm_backquote(sColumn["name"]) + " " + sColumn["type"];
			if (sColumn["notnull"]) coldef += " NOT NULL ";
			if(sColumn["dflt_value"].toUpperCase() != g_strForNull.toUpperCase()) {
				coldef += " DEFAULT " + sColumn["dflt_value"];
			}
			aQueries.push("ALTER TABLE " + sm_backquote(sTable) + " ADD COLUMN " + coldef);
			var bReturn = Database.confirmAndExecute(aQueries, "Add Column to Table " + sTable);
	  	return bReturn;
		}
		if (sOperation == "dropColumn") {
			//get the columns info
			var info = Database.getTableColumns(sTable);
			var cols = info[0];

			var aPK = [];
			var aCols = [];
			var aColNames = [];
			for(var i = 0; i < cols.length; i++) {
				var colname = cols[i][info[1]["name"][0]];
				if (colname == sColumn)
					continue;
				colname = sm_backquote(colname);
        aColNames.push(colname);

				var col = [i, colname];
				aCols.push(col);
				var primarykey = cols[i][info[1]["pk"][0]];
				if(primarykey == 1)
					aPK.push(colname);
			}
			var colList = aColNames.toString();

      var aColDefs = [];
			for(var i = 0; i < aCols.length; i++) {
				var j = aCols[i][0]
				var datatype = cols[j][info[1]["type"][0]];

				var txtNull = " NOT NULL ";
				if(cols[j][info[1]["notnull"][0]] == 0)
					txtNull = "";

				var defaultvalue = cols[j][info[1]["dflt_value"][0]];
				var defaultType = info[2][j][info[1]["dflt_value"][0]];
				if(defaultType == 0)
					defaultvalue = ""
				else
					defaultvalue = " DEFAULT " + defaultvalue + " ";

				var pk = "";
				if(aPK.length == 1 && aPK[0] == aCols[i][1])
					pk = " PRIMARY KEY ";
				var col = aCols[i][1] + " " + datatype + 
							pk + txtNull + defaultvalue;
				aColDefs.push(col);
			}
			var coldef = aColDefs.toString();

			//this is the primary key constraint on multiple columns
			var constraintPK = "";
			if(aPK.length > 1)
				constraintPK = ", PRIMARY KEY (" + aPK.toString() + ") ";

			coldef += constraintPK;

////////////////////////////
			var sTab = sm_backquote(sTable);	
			var sTempTable = g_tempNamePrefix + sTable;
			sTempTable = sm_backquote(sTempTable);
			
			var aQueries = [];
			aQueries.push("ALTER TABLE " + sTab + " RENAME TO "	+ sTempTable);
			aQueries.push("CREATE TABLE " + sTab + " (" + coldef + ")");		
			aQueries.push("INSERT INTO " + sTab + " SELECT " + colList
						+ " FROM " + sTempTable);		
			aQueries.push("DROP TABLE " + sTempTable);		
			var bReturn = Database.confirmAndExecute(aQueries, "Drop Column from " + sTable, "confirm.otherSql");
	  	return bReturn;
		}
		//should not come here
		return false;
	},

	doOKCreateTable: function() {
		var name = document.getElementById("tablename").value;
		if(name == "") {
			alert("Table Name cannot be null");
			return false;
		}
		if(name.indexOf("sqlite_") == 0) {
			alert("Table Name cannot begin with sqlite_");
			return false;
		}
		name = sm_backquote(name);

		var iTotalRows = this.numOfEmptyColumns;
		var aPK = [];
		var aCols = [];
		for(var i = 0; i < iTotalRows; i++) {
			var colname = document.getElementById("colname-" + i).value;
			if(colname.length == 0 || colname == null || colname == undefined) {
				continue;
			}
			if(colname == "rowid" || colname == "_rowid_" || colname == "oid") {
				alert("Column Name cannot be one of rowid, _rowid_, oid");
				return false;
			}
			colname = sm_backquote(colname);
			var col = [i, colname];
			aCols.push(col);
		}
		for(var i = 0; i < aCols.length; i++) {
			var j = aCols[i][0];
			var primarykey = document.getElementById("primarykey-" + j).checked;
			if(primarykey)
				aPK.push(aCols[i][1]);
		}
		
		var coldef = "";
		for(var i = 0; i < aCols.length; i++) {
			var j = aCols[i][0]
			var datatype = document.getElementById("datatype-" + j).value;
			var txtNull = " NOT NULL ";
			if(document.getElementById("allownull-" + j).checked)
				txtNull = "";
				
			var defaultvalue = document.getElementById("defaultvalue-" + j).value;
			defaultvalue = sm_makeSqlValue(defaultvalue);
			if(defaultvalue != g_strForNull)
				defaultvalue = " DEFAULT " + defaultvalue;
			else
				defaultvalue = ""
			
			var pk = "";
			if(aPK.length == 1 && aPK[0] == aCols[i][1])
				pk = " PRIMARY KEY ";
			var col = aCols[i][1] + " " + datatype + 
						pk + txtNull + defaultvalue;
			if(i > 0) 
				col = ", " + col;
			
			coldef += col; 
		}

		//this is the primary key constraint on multiple columns
		var constraintPK = "";
		if(aPK.length > 1)
			constraintPK = ", PRIMARY KEY (" + aPK.toString() + ") ";

		coldef += constraintPK;

		var txtTemp = "";
		if(document.getElementById("temptable").checked)
			txtTemp = " TEMP ";

		var txtExist = "";
		if(document.getElementById("ifnotexists").checked)
			txtExist = " IF NOT EXISTS ";

		var sQuery = "CREATE " + txtTemp + " TABLE " + txtExist + name + " (" + coldef + ")";
		return Database.confirmAndExecute([sQuery], "Create table " + name, "confirm.create");
	},

	doOKCreateView: function() {
		var name = document.getElementById("objectName").value;
		if(name == "") {
			alert("Name cannot be null");
			return false;
		}
		name = "'" + name + "'";

		var txtTemp = "";
		if(document.getElementById("tempObject").checked)
			txtTemp = " TEMP ";
			
		var txtExist = "";
		if(document.getElementById("ifnotexists").checked)
			txtExist = " IF NOT EXISTS ";
				
		var selectStatement = document.getElementById("txtSelectStatement").value;
		if(selectStatement == "") {
			alert("Name cannot be null");
			return false;
		}

		var sQuery = "CREATE " + txtTemp + " VIEW " + txtExist + name 
					+ " AS " + selectStatement;
		return Database.confirmAndExecute([sQuery], "Create View " + name, "confirm.create");
	},

	doOKCreateTrigger: function() {
		var name = document.getElementById("objectName").value;
		if(name == "") {
			alert("Name cannot be null");
			return false;
		}
		name = "'" + name + "'";

		var txtTemp = "";
		if(document.getElementById("tempObject").checked)
			txtTemp = " TEMP ";
			
		var txtExist = "";
		if(document.getElementById("ifnotexists").checked)
			txtExist = " IF NOT EXISTS ";
				
		var txtForEachRow = "";
		if(document.getElementById("foreachrow").checked)
			txtForEachRow = " FOR EACH ROW ";
				
		var whenExpression = document.getElementById("txtWhenExpression").value;
		if(whenExpression == "" || whenExpression == null) {
			whenExpression = "";
		}
		else
			whenExpression = " WHEN " + whenExpression + " ";

		var steps = document.getElementById("txtTriggerSteps").value;
		if(steps == "") {
			alert("Trigger steps cannot be empty");
			return false;
		}

		var txtTable = document.getElementById("tabletoindex").value;
		var txtTime = document.getElementById("triggerTime").selectedItem.label;
		var txtEvent = document.getElementById("dbEvent").selectedItem.label;

		var sQuery = "CREATE " + txtTemp + " TRIGGER " + txtExist + name 
					+ " " + txtTime + " " + txtEvent + " ON " + txtTable + txtForEachRow 
					+ whenExpression + " BEGIN " + steps + " END";
		return Database.confirmAndExecute([sQuery], "Create Trigger " + name, "confirm.create");
	},

	doCancel: function() {
	  return true;
	}
};
